#!/usr/local/bin/perl

##############################################################################
# PROGRAM : Bannermaster Rotator                                             #
#         : This is for use in a NON-SSI Call !!!                            #
# VERSION : 2.02                                                             #
#                                                                            #
# NOTES   :                                                                  #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996 -> 2014                                                 #
#           John C. Cokos, The CCS Network, The Interactive Web              #
#           All Rights Reserved.                                             #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
##############################################################################

require("iweb.pm"); 
&parse_form;

$group = $input{'group'};
$account = $input{'account'};
$show = $input{'show'};

# Cleanup the dirty stuff...
   unlink "$data_dir/groups/.grp";
   unlink "$data_dir/groups/.last";


# Find the group / account file...
if ($account ne "") { &Use_Account; }
else { &Use_Group; }

# Show the banner
&Show_Banner;

##############################################################################
#  Show a banner for a specific account
##############################################################################
sub Use_Account {

   ### Make sure it's not disabled ....
   if ( -e "$data_dir/accounts/$account/DISABLED" ) { 

       $group = "default";
       &Use_Group; 

   }

   else {

      ### Update the Account and Get the banner file.
      bmUpdate_Account($account,"acct");

   }

}



##############################################################################
#  Show a banner for a specific group 
##############################################################################
sub Use_Group {

   if (-e "$data_dir/groups/$group.grp") {

        open ("GRP", "$data_dir/groups/$group.grp");
            @count = <GRP>;
        close(GRP);

        if ($#count < 0) { $group = "default"; }

   }

   else { $group = "default"; }

   open ("GRP", "$data_dir/groups/$group.grp");
       @grp1 = <GRP>;
   close(GRP);

   for $g(0 .. $#grp1) {
      $a1 = $grp1[$g];
      $a1 =~ s/\cM//g;
      $a1 =~ s/\n//g;
      $a1 =~ s/\r//g;
      if (! -e "$data_dir/accounts/$a1/DISABLED") {
         $found++;
         push @grp_accounts,$a1;
      }
   }

   if ($found < 1) {

       $group = "default";

       open ("GRP", "$data_dir/groups/$group.grp");
           @grp1 = <GRP>;
       close(GRP);

       for $g(0 .. $#grp1) {
          $a1 = $grp1[$g];
          $a1 =~ s/\cM//g;
          $a1 =~ s/\n//g;
          $a1 =~ s/\r//g;
          if (! -e "$data_dir/accounts/$a1/DISABLED") {
             $found++;
             push @grp_accounts,$a1;
          }
       }
   }


   open ("LST", "$data_dir/groups/$group.last");
       @last = <LST>;
   close(LST);


   ### Get the name of the last banner shown
   $Last_Banner_Shown = $last[0];
   $Last_Banner_Shown =~ s/\n//g;

   ### Go through the group file to find it.
   ### If we are at the end of the group, start over
   ### If not, then show the next one.
   $Num_Groups = $#grp_accounts;
   $Found = "F";

   for $x (0 .. $#grp_accounts) {
      $acct = $grp_accounts[$x];
      $acct =~ s/\n//g;
      $acct =~ s/\cM//g;

      if ($acct eq $Last_Banner_Shown) {
         if ($x >= $Num_Groups) {
            $Next_Banner_To_Show = 0;
            $account = $grp_accounts[$Next_Banner_To_Show];
            $account =~ s/\n//g;
            $account =~ s/\cM//g;
            $Found = "T";
         }
         else { 
            $Next_Banner_To_Show = $x + 1;
            $account = $grp_accounts[$Next_Banner_To_Show];
            $account =~ s/\n//g;
            $account =~ s/\cM//g;
            $Found = "T";
         }
         if ($Found eq "T") { last; }
      }
   }

   ## If we fail, start over ##
   if ($Found eq "F") { $account = $grp_accounts[0]; }

   &lock("$group");

   open ("LAST",">$data_dir/groups/$group.last");
      print LAST "$account\n";
   close(LAST); 

   &unlock("$group");


   ### Update the Account and Get the banner file.
   bmUpdate_Account($account,"grp");

}


sub Show_Banner {

   if ($LOCAL eq "T") {

      $adcookie = "account\~$account";
      print "Set-Cookie:ad=$adcookie;path=/\n";
      print "Content-type: image/gif\n\n";
      open("GIF","$real_image");
      binmode(STDOUT);
      while (read(GIF,$buffer,4096)) {
          print $buffer;
      }
      close(GIF);
   }

   else  {
      $adcookie = "account\~$account";
      print "Set-Cookie:ad=$adcookie;path=/\n";
      print "Location: $image\n\n";
   }

   exit 0;
}


