#!/usr/local/bin/perl

##############################################################################
# PROGRAM : Bannermaster Rotator Link Exchange System                        #
# VERSION : 2.00                                                             #
#                                                                            #
# NOTES   :                                                                  #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996 -> 2014                                                 #
#           John C. Cokos, The CCS Network, The Interactive Web              #
#           All Rights Reserved.                                             #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
##############################################################################

require("iweb.pm"); 
&parse_form;

$account = $input{'account'};

# Cleanup the dirty stuff...
   unlink "$data_dir/groups/.grp";
   unlink "$data_dir/groups/.last";

#############################################################
##
## STEP 1:  Update the account to indicate another impression
##          If they have reached the minimum impressions to 
##          allow them to be re-activated, then remove the
##          DISABLED file from their account.
##
#############################################################
&Check_Account;


#############################################################
##
## STEP 2:  Now, get the next banner in the list
##
#############################################################
&Get_Next_Banner;



#############################################################
##
## STEP 3:  Update that account with num_impressions and 
##          if it's not a paid acct, then DISABLE IT
#############################################################
&bmUpdate_Account($ACCOUNT,"Exchange");


#############################################################
##
## STEP 4:  Show the banner
##
#############################################################
&Show_Banner;


exit 0;



sub Check_Account {
   
   $file = "$data_dir/accounts/$account/exchange.dat";
   $disabled = "$data_dir/accounts/$account/DISABLED";

   open(CHECK,"$file");
        @chk = <CHECK>;
   close(CHECK);

   $chk[0] =~ s/\cM//g;
   $chk[0] =~ s/\n//g;
   $chk[0] =~ s/\r//g;
   $shown = $chk[0];
   $shown++;

   if ($shown >= $bm_minimum) {
      unlink ($disabled);
      open(DAT,">$data_dir/accounts/$account/exchange.dat");
        print DAT "1";
      close(DAT);
   }
   else {
      open(DAT,">$data_dir/accounts/$account/exchange.dat");
        print DAT "$shown";
      close(DAT);
   }

}


sub Get_Next_Banner {


   open ("GRP", "$data_dir/groups/exchange.grp");
       @grp1 = <GRP>;
   close(GRP);

   for $g(0 .. $#grp1) {
      $a1 = $grp1[$g];
      $a1 =~ s/\cM//g;
      $a1 =~ s/\n//g;
      $a1 =~ s/\r//g;
      if (! -e "$data_dir/accounts/$a1/DISABLED") {
         push @grp_accounts,$a1;
      }
   }

   open ("LST", "$data_dir/groups/exchange.last");
       @last = <LST>;
   close(LST);


   ### Get the name of the last banner shown
   $Last_Banner_Shown = $last[0];
   $Last_Banner_Shown =~ s/\n//g;

   ### Go through the group file to find it.
   ### If we are at the end of the group, start over
   ### If not, then show the next one.
   $Num_Groups = $#grp_accounts;
   $Found = "F";

   for $x (0 .. $#grp_accounts) {
      $acct = $grp_accounts[$x];
      $acct =~ s/\n//g;
      $acct =~ s/\cM//g;

      if ($acct eq $Last_Banner_Shown) {
         if ($x >= $Num_Groups) {
            $Next_Banner_To_Show = 0;
            $ACCOUNT = $grp_accounts[$Next_Banner_To_Show];
            $ACCOUNT =~ s/\n//g;
            $ACCOUNT =~ s/\cM//g;
            $Found = "T";
         }
         else { 
            $Next_Banner_To_Show = $x + 1;
            $ACCOUNT = $grp_accounts[$Next_Banner_To_Show];
            $ACCOUNT =~ s/\n//g;
            $ACCOUNT =~ s/\cM//g;
            $Found = "T";
         }
         if ($Found eq "T") { last; }
      }
   }

   ## If we fail, start over ##
   if ($Found eq "F") { $ACCOUNT = $grp_accounts[0]; }

   &lock("exchange");

   open ("LAST",">$data_dir/groups/exchange.last");
      print LAST "$ACCOUNT";
   close(LAST); 

   &unlock("exchange");

}

sub Show_Banner {

   $adcookie = "account\~$ACCOUNT";
   print "Set-Cookie:ad=$adcookie;path=/\n";
   print "Location: $banner\n\n";

}


