#!/usr/local/bin/perl

##############################################################################
# PROGRAM : Bannermaster Reporting Utility                                   #
# VERSION : 1.75                                                             #
#                                                                            #
# NOTES   :                                                                  #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996 -> 2014                                                 #
#           John C. Cokos, The CCS Network, The Interactive Web              #
#           All Rights Reserved.                                             #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
##############################################################################

require("iweb.pm"); 
&parse_form;


$ACCOUNT = $input{'account'};
$rpt_date = $input{'date'};
$MODE = $input{'MODE'};
$mon=$input{'mon'};
$year=$input{'year'};

if ($MODE ne "admin") { &Do_Login; }
else { &Do_Admin; }


exit 0;

##############################################################################
#  Show a banner for a specific account
##############################################################################

sub Report_Account {


   print "Content-Type: text/html\n\n";
   
   print <<DONE;

    <CENTER><H1>Advertising Report .... $acct_name</H1>
    <FORM ACTION="$PROG_URL" METHOD="POST">
       New Report For:
         <SELECT NAME="mon">
           <OPTION VALUE="1">January
           <OPTION VALUE="2">Februrary
           <OPTION VALUE="3">March
           <OPTION VALUE="4">April
           <OPTION VALUE="5">May
           <OPTION VALUE="6">June
           <OPTION VALUE="7">July
           <OPTION VALUE="8">August
           <OPTION VALUE="9">September
           <OPTION VALUE="10">October
           <OPTION VALUE="11">November
           <OPTION VALUE="12">December
         </SELECT>
         <SELECT NAME="year">
           <OPTION VALUE="1998">1998
           <OPTION VALUE="1999">1999
           <OPTION VALUE="2000">2000
           <OPTION VALUE="2001">2001
         </SELECT>
         <INPUT TYPE="hidden" NAME="account" VALUE="$ACCOUNT">
         <INPUT TYPE="hidden" NAME="login_id" VALUE="$login">
         <INPUT TYPE="hidden" NAME="password" VALUE="$password">
         <INPUT TYPE="hidden" NAME="MODE" VALUE="$MODE">
         <INPUT TYPE="submit">
    </FORM>

DONE

   if($mon eq "") {
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
      $mon++;

      if ($year < 100) { $year = "19$year"; }
      else { $year = ($year - 100) + 2000; }
   }

   if($mon eq "1") { $month = "January"; }
   if($mon eq "2") { $month = "Februrary"; }
   if($mon eq "3") { $month = "March"; }
   if($mon eq "4") { $month = "April"; }
   if($mon eq "5") { $month = "May"; }
   if($mon eq "6") { $month = "June"; }
   if($mon eq "7") { $month = "July"; }
   if($mon eq "8") { $month = "August"; }
   if($mon eq "9") { $month = "September"; }
   if($mon eq "10") { $month = "October"; }
   if($mon eq "11") { $month = "November"; }
   if($mon eq "12") { $month = "December"; }

   &Month_Report;
   
}

sub Month_Report {

   $imp_referer={};
   $clk_referer={};
   $totals={};

   $clk_count = 0;
   $tot_count = 0;
   $imp_count = 0;


   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   $tot_file = "$data_dir/accounts/$ACCOUNT/$ACCOUNT.total";
   open("TOT1","$tot_file");
      @entries=<TOT1>;
   close(TOT1);
   $entries[0] =~ s/\n//g;
   @totals = split(/\|/,$entries[0]);
   $impressions = $totals[0];
   $clicks = $totals[1];


   if($windows eq "YES") { $log_dir = "$base_path\\accounts\\$ACCOUNT\\logs"; }
   else { $log_dir = "$data_dir/accounts/$ACCOUNT/logs"; }

   opendir(FILES, "$log_dir") || die ERROR("Can't open log directory ($log_dir) <BR>($windows)<BR>");
     @files=readdir(FILES);
   closedir(FILES);

    for $m( 0 .. $#files ) {
        $mth_file = $files[$m];
        $mth = $files[$m];
        $mth =~ s/\.log//g;
        $mth =~ s/\cM//g;
        $mth =~ s/\n//g;
        $mth =~ s/\r//g;
        @name = split(/_/,$mth);
        if($name[0] eq $mon && $name[2] eq $year) { push @filelist,$mth_file; }
    }

    for $z( 0 .. $#filelist ) {

        $file = $filelist[$z];
        $filebase = $filelist[$z];
        $str = $filelist[$z];
        $filebase =~ s/\.log//g;
        $filebase = "$data_dir/accounts/$ACCOUNT/logs/$filebase";
        $str =~ s/\.log//g;
        @this = split(/_/,$str);
          if(length($this[0]) == 1) { $this[0] = "0$this[0]"; }
          if(length($this[1]) == 1) { $this[1] = "0$this[1]"; }
          if(length($this[2]) == 1) { $this[2] = "0$this[2]"; }
        
        $date = "$this[0]_$this[1]_$this[2]";

        if($file =~ /.*\.log/ ) {

           ### Tally the daily impressions ###
           open ("LOG","$filebase.log") || &ERROR("Cant open $filebase.log");
              @log=<LOG>;
           close(LOG);

           open ("CLK","$filebase.clicks");
              @clk=<CLK>;
           close(CLK);

           if ($#clk < 0) { $tot_clicks = 0; }
           else { $tot_clicks = $#clk + 1; }
           @{$totals[$tot_count++]}{qw( date impressions clicks )}=
             ( $date, $#log +1, $tot_clicks ); 
             $month_imp = $month_imp + ($#log + 1);
             $month_clicks = $month_clicks + ($tot_clicks);
        }

    }
       $acct_name =~ s/_/ /g;

       if ( $impressions <= 0 ) { $impressions = 1; }
       $pct = $clicks / $impressions;
       $pct = $pct*100;

       if ( $month_imp <= 0 ) { $month_imp = 1; }
       $mpct = $month_clicks / $month_imp;
       $mpct = $mpct*100; 
        

       print "<H3>Grand Total: $impressions Impressions / $clicks Clicks \n";
       printf ("( %2.2f \% )\n", $pct);
       print "</H3>\n";
       print "<BLOCKQUOTE>\n";
       print "<H4>Daily Totals for <B>$month '$year</B>: $month_imp Impressions / $month_clicks Clicks \n";
       printf ("( %2.2f \% )\n", $mpct);
       print "</H4>\n";
       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Date</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Impressions</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Clicks</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">PCT</TD></TR>\n";

       @REPORT = sort { $a->{'date'} cmp $b->{'date'} } @totals; 

       for $t( 0 .. $#REPORT ) {
          $date=$REPORT[$t]{'date'};
          $date1=$date;
          $date1 =~ s/_/\//g;
          if ( substr($date,0,1) eq "0" ) {
              $date = substr($date,1,10);
          }

          if ($MODE eq "admin") {
             $link = "$PROG_URL?account=$ACCOUNT&action=detail&date=$date&MODE=admin";
          }
          else {
             $link = "$PROG_URL?account=$ACCOUNT&action=detail&date=$date&login_id=$login&password=$password";
          }
          print "<TR BGCOLOR=\"$win_color\">\n";
          print "<TD><center><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
 
          if ($REPORT[$t]{'clicks'} >= 1) {
             print "  <a href=\"$link\"><B>$date1</B></a></center></TD>\n";
          }
          else {
             print "  <B>$date1</B></center></TD>\n";
          }
 
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$REPORT[$t]{'impressions'}</TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$REPORT[$t]{'clicks'}</TD>\n";
 
          if ( $REPORT[$t]{'impressions'} <= 0 ) { $REPORT[$t]{'impressions'} = 1; }
          $pct = $REPORT[$t]{'clicks'} / $REPORT[$t]{'impressions'};
          $pct = $pct*100;
          if ($pct > 1.5) { $pct_color = "blue"; }
          elsif ($pct >= .6 ) { $pct_color = "$text_color"; }
          else { $pct_color="red"; }

          printf ("<TD><FONT FACE=\"$font_face\" COLOR=\"$pct_color\">%2.2f \%</TD></TR>\n", $pct);
       }
       print "</TABLE>\n";
       print "</TD></TR></TABLE>\n";



    exit 0;

}

sub Account_Detail {

   $imp_referer={};
   $clk_referer={};
   $totals={};

   $clk_count = 0;
   $tot_count = 0;
   $imp_count = 0;

   $acct_name = $ACCOUNT;
   $acct_name =~ s/_/ /g;

   print "Content-Type: text/html\n\n";

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   $click_file = "$data_dir/accounts/$ACCOUNT/logs/$rpt_date.clicks";

   ### Tally the daily clicks ###
   open ("CLK","$click_file");
        @clicks=<CLK>;
   close(CLK);

           for $k ( 0 .. $#clicks ) {
              $clicks[$k] =~ s/\n//g;
              @lines = split(/\|/,$clicks[$k]);
              $time = $lines[0];
              $page = $lines[1];
              $source = $lines[2];

              @{$clk_referer[$clk_count++]}{qw( date page )}=
                 ( $date, $page );
           }



       @clicks = sort { $a->{'page'} <=> $b->{'page'} } @clk_referer; 

       for $x ( 0 .. $#clicks ) {
          $DoneWithThisOne = "F";
          $ThisPage = $clicks[$x]{'page'};
          if ($#totals >= 0) {
            for $t (0 .. $#totals) {


                if ($totals[$t]{'page'} eq $ThisPage) {
                    $totals[$t]{'clicks'}++;
                    $DoneWithThisOne = "T";
                }
            }

            if ($DoneWithThisOne ne "T") {
                @{$totals[$tot_count++]}{qw( date page clicks )}=
                 ( $date, $ThisPage, 1 );
            }
            $DoneWithThisOne = "F";

          }

          else {
             @{$totals[$tot_count++]}{qw( date page clicks )}=
              ( $date, $ThisPage, 1 );
          }

       } 


       ## This for readability only ...
       for $t (0 .. $#totals) {
           if ($totals[$t]{'page'} eq "") {
               $totals[$t]{'page'} = "NO Referring Page (Internal)"; 
           }
       }

       $acct_name =~ s/_/ /g;
       print "<CENTER><H1>Detail Report (Clicks).... $acct_name</H1>\n";

       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\"><CENTER><U>Page</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\"><CENTER><U>Clicks</TD></TR>\n";

       for $t( 0 .. $#totals ) {
          $date = $totals[$t]{'date'};
          $date =~ s/\//_/g;
          $link = "$PROG_URL?account=$ACCOUNT&rpt_type=detail&date=$date";
          print "<TR BGCOLOR=\"$win_color\">\n";
          print "<TD><center><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
          print "  <a href=\"$totals[$t]{'page'}\">$totals[$t]{'page'}</a></center></TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'clicks'}</TD></TR>\n";
 
       }

       print "</TABLE>\n";
       print "</TD></TR></TABLE>\n";


   exit 0;
}


sub GetLogin {


    print "Content-Type: text/html\n\n";

    print <<DONE;

	<HTML>
	<HEAD>
	  <TITLE>Bannermaster Login</TITLE>
	</HEAD>
        <BODY BGCOLOR=\"$pg_color\">
        <CENTER>
        <BR><BR><BR>
        <TABLE BORDER=2 CELLSPACING=0 CELLPADDING=0>
          <TR><TD> 

        <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
          <TR><TD> 
            <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
               <TR BGCOLOR="$title_color"><TD> 
               <FONT FACE="$font_face" COLOR="$ttxt_color" SIZE=+1>Enter Login Information
            </TD><TR></TABLE>
          </TD></TR>

          <TR><TD> 
            <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%"><TR BGCOLOR="$win_color"><TD> 
              <FONT COLOR="$text_color"><FORM ACTION="$PROG_URL" METHOD="post">
              <PRE>
     Account Name: <INPUT NAME="account">
     Login Name  : <INPUT NAME="login_id">
     Password    : <INPUT TYPE="password" NAME="password"></PRE>
            <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Login"></CENTER></FORM>
            </TD><TR></TABLE>

        </TD><TR></TABLE>
        </TD><TR></TABLE>
	</BODY>
	</HTML>
DONE

    exit 0;
}



sub Do_Login {

   # Open the account's .dat file and validate the username / password
   $login = $input{'login_id'};
   $password = $input{'password'};

   if ( ! $login ) {

       &GetLogin;
       exit 0;
   }
 
   open ("DAT","$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @account_info=<DAT>;
   close("DAT");

   $account_info[0] =~ s/\n//g;

   ($acct_name,$acct_login,$acct_password,$target,$redirect_url,$alt_text,$under_text,$banner_type,$banner,$banner_width,$banner_height,$banner_text,$expiration_type,$num_clicks,$num_impressions,$start_date,$end_date) = split(/\|/,$account_info[0]);

   if ( $login eq $acct_login && $password eq $acct_password ) { 
        $action = $input{'action'};
          if ($action eq "detail") { &Account_Detail; }
          else { &Report_Account; }
   }
   else { &GetLogin; }

}


sub Do_Admin {


        $action = $input{'action'};
          if ($action eq "detail") { &Account_Detail; }
          else { &Report_Account; }

        exit 0;

}
